import requests
import re
import json
import urllib3

# ============================================================
# 🌐 Facebook: https://www.facebook.com/itvanhai.dev9x
# 💡 Mã nguồn này tôi có sử dụng hỗ trợ từ AI để phát triển.
# ⚠️ Nếu bạn sử dụng cho mục đích thương mại, vui lòng giữ nguyên phần ghi chú này để tôn trọng tác giả.
# ============================================================


urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)

class FacebookAdAccountStatusChecker:
    def __init__(self, cookies):
        self.session = requests.Session()
        self.session.verify = False
        self.cookie_dict = {}
        for cookie in cookies.split(';'):
            cookie = cookie.strip()
            if '=' in cookie:
                key, value = cookie.split('=', 1)
                self.cookie_dict[key.strip()] = value.strip()
        self.session.cookies.update(self.cookie_dict)
        self.c_user = self.cookie_dict.get('c_user')
        
        self.default_headers = {
            'User-Agent': "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/136.0.0.0 Safari/537.36",
            'sec-ch-ua': "\"Chromium\";v=\"136\", \"Google Chrome\";v=\"136\", \"Not.A/Brand\";v=\"99\"",
            'sec-ch-ua-mobile': "?0",
            'sec-ch-ua-platform': "\"Windows\"",
            'sec-ch-ua-platform-version': "\"19.0.0\"",
            'sec-ch-ua-model': "\"\"",
            'sec-ch-ua-full-version-list': "\"Chromium\";v=\"136.0.7103.114\", \"Google Chrome\";v=\"136.0.7103.114\", \"Not.A/Brand\";v=\"99.0.0.0\"",
            'sec-ch-prefers-color-scheme': "dark",
            'accept-language': "vi,fr-FR;q=0.9,fr;q=0.8,en-US;q=0.7,en;q=0.6"
        }
        
        self.lsd_token = None
        self.dtsg_token = None
        self.session_id = None
    
    def extract_tokens(self):
        url = "https://www.facebook.com/business-support-home/"
        params = {'landing_page': "overview"}
        
        headers = self.default_headers.copy()
        headers.update({
            'Accept': "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.7",
            'cache-control': "max-age=0",
            'dpr': "1",
            'viewport-width': "1920",
            'upgrade-insecure-requests': "1",
            'sec-fetch-site': "same-origin",
            'sec-fetch-mode': "navigate",
            'sec-fetch-user': "?1",
            'sec-fetch-dest': "document",
            'referer': f"https://www.facebook.com/business-support-home/{self.c_user}/",
            'priority': "u=0, i"
        })
        
        response = self.session.get(url, params=params, headers=headers)
        
        self.lsd_token = re.search(r'"LSD"[^{]*{"token":"([^"]+)"', response.text).group(1) if re.search(r'"LSD"[^{]*{"token":"([^"]+)"', response.text) else None
        self.dtsg_token = re.search(r'"DTSGInitialData"[^{]*{"token":"([^"]+)"', response.text).group(1) if re.search(r'"DTSGInitialData"[^{]*{"token":"([^"]+)"', response.text) else None
        self.session_id = re.search(r'"sessionID":"([^"]+)"', response.text).group(1) if re.search(r'"sessionID":"([^"]+)"', response.text) else None
        
        if not all([self.lsd_token, self.dtsg_token, self.session_id]):
            missing_tokens = []
            if not self.lsd_token: missing_tokens.append("LSD Token")
            if not self.dtsg_token: missing_tokens.append("DTSG Token")
            if not self.session_id: missing_tokens.append("Session ID")
            print(f"Lỗi: Không thể lấy được {', '.join(missing_tokens)}")
            return None
        
        return {
            'lsd_token': self.lsd_token,
            'dtsg_token': self.dtsg_token,
            'session_id': self.session_id
        }
    
    def get_account_quality_data(self):
        url = "https://www.facebook.com/api/graphql/"
        params = {
            '_callFlowletID': "0",
            '_triggerFlowletID': "1",
            'qpl_active_e2e_trace_ids': ""
        }
        
        payload = {
            'av': self.c_user,
            'session_id': self.session_id,
            '__aaid': "0",
            '__user': self.c_user,
            '__a': "1",
            '__req': "1",
            '__hs': "20232.BP:DEFAULT.2.0...0",
            'dpr': "1",
            '__ccg': "GOOD",
            '__rev': "1023168826",
            '__s': "u4rdkr:v017kh:arfuor",
            '__hsi': "7508047858591728347",
            '__dyn': "7xeUmxa3-Q5E5ObwKBAjwIBwCwpUnCwYwqovzEdF8iBxa7EiwnobES2S2q1Vw8i9xe6Ehw9yq15wmE38wlpEK12wLy8sg9Bwio3nwIwEwk89oeUuyo462mcw4wz84a4ouyUd85W7o2lwBgao6C3m2y1bxq0wEpx2ewyx6i2GU8U-U7O2q4UoG7o2swh8S1qxa1ozEjxu16w9-fxi3-1RwrUux616yES2e0UE2ZwrU6Ci9wwwiUWawCwNwDwr8rwjo5Ou3a0IqwIwtU5K0JFHwwxS12w44oiw",
            '__hsdp': "gSMP3EQwoIbEMmJ3oBrk--mmm2q5Ci225k44J5WICgxo8No4W5EkUaQHGbJ4itAxBaaxKF2yu2q7O1efBAwmEGq0Om3egMsg2NwhCha2a3y48gwCAyU1X81sErxpwva4zm",
            '__hblp': "0Wwa66E4u2m3u0he0ly0AU-084wEwdC12w8i0QU1jQ1Qo5-0qi1FwWw3kUO0z80yC7E4W2G0yEKiU1vU-0oy0hO0w84O48qwbyu3i18w5HwdyUowcW0Bbwb6dwm827wnE4S15g2Fw9eim0PEW1sw8W69ESu2uS58Gp95wFy8yE_F2lkxd1Sm8x192oR6wSx2HxeeCDyfBxm58Cag-hooQ5UogbUy4UGqq7A7Ujioll6QFVU8kA5UJ28kwl8y6V82Iw9i7x4OwxgbUjCG2O2m1hwm8vK7812E563K3m12xC6FEhwa23q4o8oS321kUC7XwhoK3-7EcE2hxu",
            'fb_dtsg': self.dtsg_token,
            'jazoest': "null",
            'lsd': self.lsd_token,
            '__spin_r': "1023168826",
            '__spin_b': "trunk",
            '__spin_t': "1748103615",
            'fb_api_caller_class': "RelayModern",
            'fb_api_req_friendly_name': "AccountQualityHubOverviewQuery",
            'variables': "{}",
            'server_timestamps': "true",
            'doc_id': "9420838364680513"
        }
        
        headers = self.default_headers.copy()
        headers.update({
            'origin': "https://www.facebook.com",
            'priority': "u=1, i",
            'referer': "https://www.facebook.com",
            'sec-fetch-dest': "empty",
            'sec-fetch-mode': "cors",
            'sec-fetch-site': "same-origin",
            'x-asbd-id': "359341",
            'x-fb-friendly-name': "AccountQualityHubOverviewQuery",
            'x-fb-lsd': self.lsd_token
        })
        
        response = self.session.post(url, params=params, data=payload, headers=headers, verify=False)
        return response.json()
    
    def parse_account_data(self, data):
        results = {
            'account_user': [],
            'ad_businesses': []
        }
        
        if 'data' in data and 'viewer' in data['data']:
            viewer = data['data']['viewer']
            
            if 'account_user' in viewer:
                account = viewer['account_user']
                status = "Bị vô hiệu hoá" if account.get('advertising_restriction_info', {}).get('is_restricted', False) else "Hoạt động bình thường"
                results['account_user'].append({
                    'id': account.get('id'),
                    'name': account.get('name'),
                    'status': status
                })
            
            if 'ad_businesses' in viewer and 'nodes' in viewer['ad_businesses']:
                for business in viewer['ad_businesses']['nodes']:
                    status = "Bị vô hiệu hoá" if business.get('advertising_restriction_info', {}).get('is_restricted', False) else "Hoạt động bình thường"
                    results['ad_businesses'].append({
                        'id': business.get('id'),
                        'name': business.get('name'),
                        'status': status
                    })
        
        return results
    
    def display_results(self, results):
        print("=" * 60)
        print("ACCOUNT USER:")
        print("=" * 60)
        for account in results['account_user']:
            print(f"ID: {account['id']}")
            print(f"Name: {account['name']}")
            print(f"Status: {account['status']}")
            print("-" * 40)
        
        print("\nAD BUSINESSES:")
        print("=" * 60)
        for business in results['ad_businesses']:
            print(f"ID: {business['id']}")
            print(f"Name: {business['name']}")
            print(f"Status: {business['status']}")
            print("-" * 40)
    
    def run(self):
        print("Extracting tokens...")
        tokens = self.extract_tokens()
        if tokens is None:
            return None
        
        print(f"LSD Token: {tokens['lsd_token']}")
        print(f"DTSG Token: {tokens['dtsg_token']}")
        print(f"Session ID: {tokens['session_id']}")
        
        print("\nGetting account quality data...")
        data = self.get_account_quality_data()
        
        print("\nParsing results...")
        results = self.parse_account_data(data)
        
        self.display_results(results)
        return results


# Định dạng key=value; key1=value1

cookies = ""

extractor = FacebookAdAccountStatusChecker(cookies)
results = extractor.run()